import java.io.File;
import java.io.FileFilter;
import java.io.IOException;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.zip.ZipEntry;
import java.lang.reflect.Method;
import java.util.ArrayList;

public class FindClass {
	// change the next line to point to the Java libraries folder.
    private static final String SEARCH_PATH = "C:/Program Files/Java/jre8/lib/";
    private static String theClass;
    private static List<String> foundIn = new LinkedList<>();

    public static List<String> lookFor(String theclass) {
        File start;
        theClass = theclass;
		foundIn.clear();
        Scanner dummy = new Scanner(SEARCH_PATH);
        start = new File(SEARCH_PATH);
        if (!theClass.endsWith(".class")) {
            theClass = theClass.replace('.', '/') + ".class";
        }
        search(start);
		dummy.close();
        return foundIn;
    }

    private static void search(File start) {
        try {
            final FileFilter filter = new FileFilter() {
                public boolean accept(File pathname) {
                    return pathname.getName().endsWith(".jar") || pathname.isDirectory();
                }
            };
            for (File f : start.listFiles(filter)) {
                if (f.isDirectory()) {
                    search(f);
                } else {
                    searchJar(f);
                }
            }
        } catch (Exception e) {
            System.err.println("Error at: " + start.getPath() + " " + e.getMessage());
        }
    }

    private static void searchJar(File f) {
        try {
            try (JarFile jar = new JarFile(f)) {
                ZipEntry e = jar.getEntry(theClass);
                if (e == null) {
                    Enumeration<JarEntry> en = jar.entries();
                    while (en.hasMoreElements()) {
                        JarEntry je = en.nextElement();
                        if (je.getName().toLowerCase().contains(theClass.toLowerCase())) {
                            foundIn.add(je.getName());
                        }
                    }
                }
                if (e != null) {
                    foundIn.add(f.getPath());
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        } 
    }
    public List<String> getMethods(String cname) {
        List<String> li = new ArrayList<>();
        Method[] methods = null;
        Class<?> c = null;
        try {
            c = Class.forName(cname);
            methods = c.getDeclaredMethods();
			//System.out.println("Method count = " + methods.length);
			if (methods.length > 0 && methods != null){
				for (int a = 0; a < methods.length; a++) {
					//System.out.println("[" + a + "] " + methods[a].toString()); 
					li.add(methods[a].toString());
				}
			}
        } catch (ClassNotFoundException ex) {
            System.out.println("Class not found");
        }
        return li;
    }
}
